//------------------------------------------------------------------
#property copyright   "www.forex-tsd.com"
#property link        "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 11
#property indicator_color1  clrGainsboro
#property indicator_color2  clrGainsboro
#property indicator_color3  clrSilver
#property indicator_color4  clrSilver
#property indicator_color5  clrSilver
#property indicator_color6  clrPowderBlue
#property indicator_color7  clrGold
#property indicator_color8  clrDeepSkyBlue
#property indicator_color9  clrDeepSkyBlue
#property indicator_color10 clrSandyBrown
#property indicator_color11 clrSandyBrown
#property indicator_style4  STYLE_DOT
#property indicator_style5  STYLE_DOT
#property strict

//
//
//
//
//

enum enColorOn
{
   cc_onMiddle,  // Change color on middle level cross
   cc_onLevel,   // Change color on upper level cross
   cc_onTrend    // Change color on trend change
};

extern ENUM_TIMEFRAMES    TimeFrame    = PERIOD_CURRENT; // Time frame
extern string             ForSymbol    = "";             // For symbol (leave empty for current chart symbol)
extern int                CalcPeriod   = 20;             // calculation period
extern double             LevelUp      = 60;             // High level
extern double             LevelMiddle  = 50;             // Treshold
extern double             LevelDown    = 10;             // Low level
extern enColorOn          ColorOn      = cc_onLevel;     // Color change :
extern bool               alertsOn        = true;        // Turn alerts on?
extern bool               alertsOnCurrent = false;       // Alerts on currnt (still opened) bar?
extern bool               alertsMessage   = true;        // Alerts should show pop-up message?
extern bool               alertsSound     = false;       // Alerts should play alert sound?
extern bool               alertsPushNotif = false;       // Alerts should send push notification?
extern bool               alertsEmail     = false;       // Alerts should send email?
extern int                LineWidth    = 5;              // Line width
extern bool               Interpolate  = true;           // Interpolate in multi time frame?

//
//
//
//
//

double hhllh[],hhlll[];
double hhllUa[];
double hhllUb[];
double hhllDa[];
double hhllDb[];
double levup[];
double levmi[];
double levdn[];
double trendh[],trendl[],shadh[],shadl[];

string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(13);
   SetIndexBuffer( 0,shadh);  SetIndexStyle(0,EMPTY,EMPTY,LineWidth+2);
   SetIndexBuffer( 1,shadl);  SetIndexStyle(1,EMPTY,EMPTY,LineWidth+2);
   SetIndexBuffer( 2,levup);
   SetIndexBuffer( 3,levmi);
   SetIndexBuffer( 4,levdn);
   SetIndexBuffer( 5,hhllh);
   SetIndexBuffer( 6,hhlll);
   SetIndexBuffer( 7,hhllUa); SetIndexStyle( 7,EMPTY,EMPTY,LineWidth);
   SetIndexBuffer( 8,hhllUb); SetIndexStyle( 8,EMPTY,EMPTY,LineWidth);
   SetIndexBuffer( 9,hhllDa); SetIndexStyle( 9,EMPTY,EMPTY,LineWidth);
   SetIndexBuffer(10,hhllDb); SetIndexStyle(10,EMPTY,EMPTY,LineWidth);
   SetIndexBuffer(11,trendh); 
   SetIndexBuffer(12,trendl); 
   
       //
       //
       //
       //
       //
      
       indicatorFileName = WindowExpertName();
       returnBars        = (TimeFrame==-99);
       TimeFrame         = MathMax(TimeFrame,_Period);
       if (ForSymbol=="") ForSymbol = _Symbol;
   IndicatorShortName(ForSymbol+" "+timeFrameToString(TimeFrame)+"  Higher high - lower low stochastic ("+(string)CalcPeriod+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
            int limit = MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { shadh[0] = limit+1; return(0); }
            if (TimeFrame != Period() || ForSymbol!=_Symbol)
            {
               limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(ForSymbol,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period())); 
               if (trendh[limit]==1) CleanPoint(limit,hhllUa,hhllUb);
               if (trendl[limit]==1) CleanPoint(limit,hhllDa,hhllDb);
               for(int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                     levup[i]  = iCustom(ForSymbol,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",CalcPeriod,LevelUp,LevelMiddle,LevelDown,ColorOn, 2,y);
                     levmi[i]  = iCustom(ForSymbol,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",CalcPeriod,LevelUp,LevelMiddle,LevelDown,ColorOn, 3,y); 
                     levdn[i]  = iCustom(ForSymbol,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",CalcPeriod,LevelUp,LevelMiddle,LevelDown,ColorOn, 4,y);
                     hhllh[i]  = iCustom(ForSymbol,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",CalcPeriod,LevelUp,LevelMiddle,LevelDown,ColorOn, 5,y);
                     hhlll[i]  = iCustom(ForSymbol,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",CalcPeriod,LevelUp,LevelMiddle,LevelDown,ColorOn, 6,y);
                     trendh[i] = iCustom(ForSymbol,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",CalcPeriod,LevelUp,LevelMiddle,LevelDown,ColorOn,11,y); 
                     trendl[i] = iCustom(ForSymbol,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",CalcPeriod,LevelUp,LevelMiddle,LevelDown,ColorOn,12,y); 
                     hhllDa[i] = EMPTY_VALUE;
                     hhllDb[i] = EMPTY_VALUE;
                     hhllUa[i] = EMPTY_VALUE;
                     hhllUb[i] = EMPTY_VALUE;
                     
                     if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                  
                     //
                     //
                     //
                     //
                     //
                  
                        int n,j; datetime time = iTime(NULL,TimeFrame,y);
                           for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
                           for(j = 1; j<n && (i+n)<Bars && (i+j)<Bars; j++)
                           {
                              levup[i+j] = levup[i] + (levup[i+n] - levup[i])*j/n;
                              levmi[i+j] = levmi[i] + (levmi[i+n] - levmi[i])*j/n;
                              levdn[i+j] = levdn[i] + (levdn[i+n] - levdn[i])*j/n;
                              hhllh[i+j] = hhllh[i] + (hhllh[i+n] - hhllh[i])*j/n;
                              hhlll[i+j] = hhlll[i] + (hhlll[i+n] - hhlll[i])*j/n;
                           }
               }
               for(int i=limit; i>=0; i--)
               {
                  shadh[i] = hhllh[i];
                  shadl[i] = hhlll[i];
                     if (trendh[i] == 1) PlotPoint(i,hhllUa,hhllUb,hhllh);
                     if (trendl[i] == 1) PlotPoint(i,hhllDa,hhllDb,hhlll);
               }
               return(0);
            }

   //
   //
   //
   //
   //

     if (trendh[limit]==1) CleanPoint(limit,hhllUa,hhllUb);
     if (trendl[limit]==1) CleanPoint(limit,hhllDa,hhllDb);
     for (int i=limit; i>=0; i--)
     {  
         double hhh = 0;
         double lll = 0;
         if (i<Bars-1) hhh = High[i]>High[i+1] ? (High[i]- High[ArrayMinimum(High,CalcPeriod,i)])/(High[ArrayMaximum(High,CalcPeriod,i)]-High[ArrayMinimum(High,CalcPeriod,i)]) :  0 ;         
         if (i<Bars-1) lll = Low[i] <Low[i+1]  ? (Low[ArrayMaximum(Low,CalcPeriod,i)]    -Low[i])/(Low [ArrayMaximum(Low ,CalcPeriod,i)]-Low [ArrayMinimum(Low ,CalcPeriod,i)]) :  0 ;         
                hhllh[i] = iEma(hhh*100,CalcPeriod,i,0);
                hhlll[i] = iEma(lll*100,CalcPeriod,i,1);
            
            levup[i]  = LevelUp;
            levmi[i]  = LevelMiddle;
            levdn[i]  = LevelDown;
            hhllDa[i] = EMPTY_VALUE;
            hhllDb[i] = EMPTY_VALUE;
            hhllUa[i] = EMPTY_VALUE;
            hhllUb[i] = EMPTY_VALUE;
            trendh[i] = 0;
            trendl[i] = 0;
            switch(ColorOn)
            {
               case cc_onLevel:
                  if (hhllh[i]>levup[i]) trendh[i] =  1;
                  if (hhllh[i]<levup[i]) trendh[i] = -1;
                  if (hhlll[i]>levup[i]) trendl[i] =  1;
                  if (hhlll[i]<levup[i]) trendl[i] = -1;
                  break;
               case cc_onMiddle:                  
                  if (hhllh[i]>levmi[i]) trendh[i] =  1;
                  if (hhllh[i]<levmi[i]) trendh[i] = -1;
                  if (hhlll[i]>levmi[i]) trendl[i] =  1;
                  if (hhlll[i]<levmi[i]) trendl[i] = -1;
                  break;
               default:                  
                  if (hhllh[i]>hhlll[i]) trendh[i] =  1;
                  if (hhllh[i]<hhlll[i]) trendl[i] =  1;
            }                 
         
         //
         //
         //
         //
         //

         shadh[i] = hhllh[i];
         shadl[i] = hhlll[i];
         if (trendh[i] ==  1) PlotPoint(i,hhllUa,hhllUb,hhllh);
         if (trendl[i] ==  1) PlotPoint(i,hhllDa,hhllDb,hhlll);
   }    
   if (alertsOn)
   {
     int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
     string add = "broke level"; if (ColorOn==cc_onTrend) add = "changed trend";
        static string   mess1 = "";
        static datetime time1 = 0;
            if (trendh[whichBar] != trendh[whichBar+1]) 
            if (trendh[whichBar] ==  1) 
            if (ColorOn==cc_onTrend)
                  doAlert(mess1,time1,whichBar,"stochastic up broke trend down up");
            else  doAlert(mess1,time1,whichBar,"stochastic up broke level");
      static string   mess2 = "";
      static datetime time2 = 0;
            if (trendl[whichBar] != trendl[whichBar+1]) 
            if (trendl[whichBar] == 1)
            if (ColorOn==cc_onTrend)
                  doAlert(mess1,time1,whichBar,"stochastic down broke trend up up");
            else  doAlert(mess1,time1,whichBar,"stochastictrend down broke level");
   }        
   return(0);
}   

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  timeFrameToString(_Period)+" - "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" "+doWhat;
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(Symbol()+" higher high - lower low stochastic",message);
          if (alertsPushNotif) SendNotification(message);
          if (alertsSound)     PlaySound("alert2.wav");
   }
}

//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

double workEma[][2];
double iEma(double tprice, double period, int r, int instanceNo=0)
{
   if (period<=1) return(tprice);
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   workEma[r][instanceNo] = tprice;
   double alpha = 2.0 / (1.0+period);
   if (r>0)
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(tprice-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}